/**
 * 
 */

function initialise(){
    document.getElementById("appTitleInHelp").innerHTML=appTitle;
    showAppTitle();
	if(!eventsInitialised){
	    exerciseType=parseInt(Math.random()*(repeat2While+1));
	    initialiseEvents();
	    eventsInitialised=true;
	}
	
	if(debug){
		exerciseType=repeat2For;
	}
	
	simulationReset();
    $("#resultsArea").hide();
    $("#messageArea").hide();

	clearCodeResults();
	generateVariationsList();
	assembleCode();
	sizeDIVs();
	if(!helpShown){
		helpShown=true;
		window.location.href="#openModalHelp";
	}
	$("#btnCloseHelp").removeClass("ui-link");
}

function initialiseEvents(){
    $("#btnHelp").on("click touchstart",function(){
    	showHelp();
    	window.location.href="#openModalHelp";
    });
	
    $("#btnNewProblem").on("click touchstart",function(){
        exerciseType=parseInt(Math.random()*(repeat2While+1));
    	initialise();
    });
    
    $("#btnDelete").on("click touchstart",function(){
    	deleteAll();
    });
    
    $("#btnPlaySource").on("click touchstart",function(){
        selectedSimulation=sourceCode;
        simulateCode();
    });
    
    $("#btnPlayStudent").on("click touchstart",function(){
        selectedSimulation=studentCode;
        simulateCode();
    });

    $("#btnPause").on("click touchstart",function(){
        $("#btnOptions").prop("disabled",false);
        //simulating=false;
        $("#btnPause").hide();
        $("#btnContinue").show();
        $("#btnForward").prop("disabled",false);
        clearInterval(timerLoop);
    });
    
    $("#btnContinue").on("click touchstart",function(){
        $("#btnOptions").prop("disabled",true);
        //simulating=true;
        $("#btnContinue").hide();
        $("#btnForward").prop("disabled",true);
        $("#btnPause").show();
        timerLoop=setInterval(function(){simulationRun();},simSpeed);
    });
    
    $("#btnStop").on("click touchstart",function(){
        simulationReset();
    });
    
    $("#btnSubmit").on("click touchstart",function(){
    	checkSolution();
    });

    $("#btnShowSolution").on("click touchstart",function(){
    	showSolution();
    });

    $("#btnHint").on("click touchstart",function(){
    	showHint();
    });

    $("#btnForward").on("click touchstart",function(){
        /*simulationAborted=false;*/
        if(selectedSimulation==studentCode && !simulationInitialised){
            simulationInitialise();
        }
        simulationRun();
        if(simulationIndex==codeLength){
            simulationReset();
        }

    });
    
    $("#closeTool").on("click touchstart",function(){
        hideHelp();
    });
    
    //Κουμπιά διαχείρισης εφαρμογής
    $("#slideSpeed").bind("change keyup touchend",function(event,ui) {
        var maxSimSpeed=Number($(this).attr("max"))+1;
        simSpeed=maxSimSpeed-$(this).val();
    });
    
    $("#showVarValues").bind("change keyup touchend",function(event,ui) {
        if($("#showVarValues:checked").val()=="show"){
            showVarValues=true;
        }
        else{
            showVarValues=false;
        }
    });
    
    $("#requestConfirmations").bind("change keyup touchend",function(event,ui) {
        if($("#requestConfirmations:checked").val()=="reqConfirm"){
            requestConfirmationState=requestConfirmation;
        }
        else{
            requestConfirmationState=dontRequestConfirmation;
        }
    });
    
    $("#showFullSimulationPath").bind("change keyup touchend",function(event,ui) {
        if($("#showFullSimulationPath:checked").val()=="showFullSimPath"){
            hideSimulationPath=false;
        }
        else{
            hideSimulationPath=true;
        }
    });
}

function clearCodeResults(){
	solutionOutputVisible=false;
	document.getElementById("originalResults").innerHTML="";
	$("#originalResults").html("");
	userOutputVisible=false;
	$("#studentResults").html("");
	document.getElementById("studentResults").innerHTML="";
	$("#solutionOk").hide();
	$("#solutionError").hide();
}

function sizeDIVs(){
	var divBorder=15;
	
	var newTop=document.getElementById("sourceCodeDIV").getBoundingClientRect().top;
	var sourceCodeLeft=divBorder;
    var codeHeight=2.5*divBorder+document.getElementById("sourceCode").getBoundingClientRect().height;
	
    $("#sourceCodeDIV").css({
        left: sourceCodeLeft+"px",
        height: codeHeight+"px"
    });
	var studentCodeLeft=sourceCodeLeft+document.getElementById("sourceCodeDIV").getBoundingClientRect().width+divBorder;

    $("#tdExecuteOriginal").css({
        width: (studentCodeLeft-divBorder)+"px"
    });
    
	
	$("#studentCodeDIV").css({
        top: newTop+"px",
        left: studentCodeLeft+"px"
    });
	var solutionResultsLeft=studentCodeLeft+document.getElementById("studentCodeDIV").getBoundingClientRect().width+divBorder;
	$("#solutionResultsDIV").css({
        top: newTop+"px",
        left: solutionResultsLeft+"px",
        width: "42px"
    });
	var height1=document.getElementById("sourceCodeDIV").getBoundingClientRect().height;
	var height2=document.getElementById("studentCodeDIV").getBoundingClientRect().height;
	var maxHeight=Math.max(height1,height2)+divBorder;
	$("#exerciseArea").css({
        height: maxHeight+"px"
    });


	//Αποτελέσματα
	$("#originalResults").css({
        left: sourceCodeLeft+"px",
        height: 70+"px"
    });
    $("#studentResults").css({
        left: studentCodeLeft+"px",
        height: 70+"px"
    });
	var resultsAreaWidth=studentCodeLeft+document.getElementById("studentCodeDIV").getBoundingClientRect().width-2*divBorder;
	$("#resultsArea").css({
	    left: sourceCodeLeft+"px",
	    width: resultsAreaWidth+"px",
	    height: 120+"px"
    });
	$("#messageArea").css({
	    left: sourceCodeLeft+"px",
	    width: resultsAreaWidth+"px",
	    height: 120+"px"
    });
}

function assembleCode(){
	var sourceCode="";
	var exerciseCode="";
	switch(exerciseType){
	case for2While:
		sourceCode=generateForLoop(generateFullCode);
		exerciseCode=generateWhileLoop(generatePartialCode);
		break;
	case for2Repeat:
		sourceCode=generateForLoop(generateFullCode);
		exerciseCode=generateRepeatLoop(generatePartialCode);
		break;
	case while2For:
		sourceCode=generateWhileLoop(generateFullCode);
		exerciseCode=generateForLoop(generatePartialCode);
		break;
	case while2Repeat:
		sourceCode=generateWhileLoop(generateFullCode);
		exerciseCode=generateRepeatLoop(generatePartialCode);
		break;
	case repeat2For:
		sourceCode=generateRepeatLoop(generateFullCode);
		exerciseCode=generateForLoop(generatePartialCode);
		break;
	case repeat2While:
		sourceCode=generateRepeatLoop(generateFullCode);
		exerciseCode=generateWhileLoop(generatePartialCode);
		break;
	}
	document.getElementById("sourceCode").innerHTML=sourceCode;
	document.getElementById("studentCode").innerHTML=exerciseCode;
	hideSimulationValues();
	$('body').on('paste input', '[contenteditable]', function() {
		userOutputVisible=false;
		$("#studentResults").html("");
		clearHint();
		hideHint();
		hideResult();
        /*$("#btnPlayStudent").prop("disabled",true);*/
        $("#btnStop").prop("disabled",true);
        $("#btnForward").prop("disabled",true);
	});
}

function generateVariationsList(){
    var menuEntry="<div tabindex='0' class='onclick-menu'>";
    menuEntry+="<ul class='onclick-menu-content'>";
    for(var i=0;i<6;i++){
        menuEntry+="<li><button onclick='setProblem("+i+")'>"+variations[i]+"</button></li>";
    }
    menuEntry+="</ul>";
    menuEntry+="</div>";
    document.getElementById("levels").innerHTML=menuEntry;
}

function setProblem(slctr){
    exerciseType=slctr;
    initialise();
}

function generateEntryPlaceholder(lineNo,entryID){
	var newEntry="<span class='toChange' id='"+entryID+"' contenteditable='true'>ˍˍˍ</span>";
	if(entryID.substr(0,7)=="command"){
		var menuEntry="<div tabindex='0' class='onclick-menu'>";
		menuEntry+="<ul class='onclick-menu-content'>";
		menuEntry+="<li><button onclick='fillEntry("+lineNo+",1,\""+entryID+"\")'><b>ΓΡΑΨΕ</b> x</button></li>";
		menuEntry+="<li><button onclick='fillEntry("+lineNo+",2,\""+entryID+"\")'>x <- x</button></li>";
		menuEntry+="</ul>";
		menuEntry+="</div>";
		newEntry=newEntry+menuEntry;
	}
	else if(entryID=="comparator_endVal"){
		var menuEntry="<div tabindex='0' class='onclick-menu'>";
		menuEntry+="<ul class='onclick-menu-content'>";
		menuEntry+="<li><button onclick='fillEntry(-1,3,\""+entryID+"\")'>=</button></li>";
		menuEntry+="<li><button onclick='fillEntry(-1,4,\""+entryID+"\")'><></button></li>";
		menuEntry+="<li><button onclick='fillEntry(-1,5,\""+entryID+"\")'><</button></li>";
		menuEntry+="<li><button onclick='fillEntry(-1,6,\""+entryID+"\")'><=</button></li>";
		menuEntry+="<li><button onclick='fillEntry(-1,7,\""+entryID+"\")'>></button></li>";
		menuEntry+="<li><button onclick='fillEntry(-1,8,\""+entryID+"\")'>>=</button></li>";
		menuEntry+="</ul>";
		menuEntry+="</div>";
		newEntry=newEntry+menuEntry;
	}
	return newEntry;
}

function fillEntry(lineNo,entryType,entryID){
	var entry=document.getElementById(entryID);
	var entryID2=entryID=="command1"?"command2":"command1";
	var entry2=document.getElementById(entryID2);
	var entryText="";
	if(entryType==1){
	    outputIndex=lineNo;
		entryText="<span class='reservedWord'>ΓΡΑΨΕ</span> x";
		$("#"+entryID+"OfLoop").html("   <span class='showValues' id='xOutputStudent'></span>");
		entry2.innerHTML="x <- x ˍˍˍ";
		$("#"+entryID2+"OfLoop").html("   <span class='showValues' id='xValStudent'></span>");
		userSolutionVariation=firstUseCounterThenChangeIt;
	}
	else if(entryType==2){
	    generateNewValueIndex=lineNo;
		entryText="x <- x ˍˍˍ";
		$("#"+entryID+"OfLoop").html("   <span class='showValues' id='xValStudent'></span>");
		entry2.innerHTML="<span class='reservedWord'>ΓΡΑΨΕ</span> x";
		$("#"+entryID2+"OfLoop").html("   <span class='showValues' id='xOutputStudent'></span>");
		userSolutionVariation=firstChangeCounterThenUseIt;
	}
	else if(entryType>2){
		var currentContent=document.getElementById(entryID).innerHTML.replace("&lt;","<").replace("&gt;",">");
		var i=-1;
		while(i<2 && "<>=".indexOf(currentContent.charAt(i))>-1){
			i++;
		}
		var newComparator="";
		switch(entryType){
		case 3:
			newComparator="=";
			break;
		case 4:
			newComparator="<>";
			break;
		case 5:
			newComparator="<";
			break;
		case 6:
			newComparator="<=";
			break;
		case 7:
			newComparator=">";
			break;
		case 8:
			newComparator=">=";
			break;
		}
		currentContent=newComparator+currentContent.substr(i);
		entryText=currentContent;
	}
	entry.innerHTML=entryText;
	hideSimulationValues();
	if(entryType==2){
		var range = document.createRange();
		var sel = window.getSelection();
		range.setStart(entry.childNodes[0], 7);
		range.collapse(true);
		sel.removeAllRanges();
		sel.addRange(range);
	}
	hideHint();
	hideResult();
	clearHint();
}

function generateForLoop(generatorSelector){
	var code="";
	if(generatorSelector==generateFullCode){
		
		//Βασικές παράμετροι Δ.Ε.
		solutionStartVal=parseInt(Math.random()*100);
		solutionEndVal=parseInt(Math.random()*100);
		while(solutionEndVal==solutionStartVal){
			solutionEndVal=parseInt(Math.random()*100);
		}
		solutionStepVal=Math.sign(solutionEndVal-solutionStartVal)*parseInt(Math.random()*19);

		sourceSpecialResults="";
		defineForLimits(solutionStartVal,solutionEndVal,solutionStepVal,"originalResults",sourceCode);

		//Παραγωγή κώδικα
		code+="\n1: <span class='algoCmd' id='cmd1'><span class='reservedWord'>ΓΙΑ</span> x <span class='reservedWord'>ΑΠΟ</span> "+solutionStartVal+" <span class='reservedWord'>ΜΕΧΡΙ</span> "+solutionEndVal;
		if(solutionStepVal!=1)code+=" <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> "+solutionStepVal;
		code+="</span>   <span class='showValues' id='xCond'></span>";
		code+="\n2: <span class='algoCmd' id='cmd2'>  <span class='reservedWord'>ΓΡΑΨΕ</span> x </span>   <span class='showValues' id='xOutput'></span>";
		code+="\n3: <span class='algoCmd' id='cmd3'><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>   <span class='showValues' id='xVal'></span>";
		sourceCodeLength=3;
		solutionCommand11="<span class='reservedWord'>ΓΡΑΨΕ</span> x   <span class='showValues' id='output'></span>";
		solutionCommand12="x<-x"+solutionStepVal>=0?"+":"-"+solutionStepVal;
		if(solutionStepVal>=0){
			solutionForComparator="<=";
			solutionWhileComparator="<=";
			solutionRepeatComparator=">";
			solutionCommand2="x<-x+"+solutionStepVal;
		}
		else{
			solutionForComparator=">=";
			solutionWhileComparator=">=";
			solutionRepeatComparator="<";
			solutionCommand2="x<-x"+solutionStepVal;
		}
		solutionCommand1="<span class='reservedWord'>ΓΡΑΨΕ</span> x   <span class='showValues' id='output'></span>";
		selectedVariation=firstUseCounterThenChangeIt;
	}
	else{
		code+="\n1: <span class='algoCmd' id='cmdStudent1'><span class='reservedWord'>ΓΙΑ</span> x <span class='reservedWord'>ΑΠΟ</span> "+generateEntryPlaceholder(-1,"startVal");
		code+=" <span class='reservedWord'>ΜΕΧΡΙ</span> "+generateEntryPlaceholder(-1,"endVal");
		code+=" <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> "+generateEntryPlaceholder(-1,"stepVal")+"</span>   <span class='showValues' id='xCondStudent'></span>";
		code+="\n2: <span class='algoCmd' id='cmdStudent2'>  <span class='reservedWord'>ΓΡΑΨΕ</span> x </span>   <span class='showValues' id='xOutputStudent'></span>";
		code+="\n3: <span class='algoCmd' id='cmdStudent3'><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>   <span class='showValues' id='xValStudent'></span>";
		studentCodeLength=3;
	}
	generateNewValueIndex=2;
	outputIndex=1;
	return code;
}

function generateWhileLoop(generatorSelector){
	var code="";
	if(generatorSelector==generateFullCode){
		
		//Βασικές παράμετροι Δ.Ε.
		solutionStartVal=parseInt(Math.random()*100);
		solutionEndVal=parseInt(Math.random()*100);
		while(solutionEndVal==solutionStartVal){
			solutionEndVal=parseInt(Math.random()*100);
		}
		solutionStepVal=Math.sign(solutionEndVal-solutionStartVal)*parseInt(Math.random()*19);
		var signToShow=solutionStepVal>=0?" + ":" - ";
		
		//Επιλογή αυστηρής ανισότητας ή ανισοϊσότητας
		selectComparator();

		if(solutionEndVal>solutionStartVal){
			if(comparatorType==comparatorWithEquality){
				solutionWhileComparator="<=";	
				solutionForComparator="<=";
				solutionRepeatComparator=">";
				
				solutionEndValSpan=(solutionEndVal-solutionStartVal) % solutionStepVal;
				solutionEndLoLim=solutionEndVal-solutionEndValSpan;
				solutionEndHiLim=(Math.floor((solutionEndVal-solutionStartVal)/solutionStepVal)+1)*solutionStepVal+solutionStartVal-1;
			}
			else{
				solutionWhileComparator="<";
				solutionForComparator="<";
				solutionRepeatComparator=">=";

				solutionEndValSpan=((solutionEndVal-1)-solutionStartVal) % solutionStepVal;
				solutionEndLoLim=(solutionEndVal-1)-solutionEndValSpan;
				solutionEndHiLim=(Math.floor(((solutionEndVal-1)-solutionStartVal)/solutionStepVal)+1)*solutionStepVal+solutionStartVal-1;
			}
		}
		else{
			if(comparatorType==comparatorWithEquality){
				solutionWhileComparator=">=";
				solutionForComparator=">=";
				solutionRepeatComparator="<";

				solutionEndValSpan=Math.abs(solutionEndVal-solutionStartVal) % Math.abs(solutionStepVal);
				solutionEndLoLim=(Math.floor((solutionEndVal-solutionStartVal)/solutionStepVal)+1)*solutionStepVal+solutionStartVal+1;
				solutionEndHiLim=solutionEndVal+solutionEndValSpan;
			}
			else{
				solutionWhileComparator=">";
				solutionForComparator=">";
				solutionRepeatComparator="<=";

				solutionEndValSpan=Math.abs((solutionEndVal+1)-solutionStartVal) % Math.abs(solutionStepVal);
				solutionEndHiLim=(Math.floor(((solutionEndVal+1)-solutionStartVal)/solutionStepVal)+1)*solutionStepVal+solutionStartVal+1;
				solutionEndLoLim=(solutionEndVal+1)+solutionEndValSpan;
			}
		}
		solutionComparator=solutionWhileComparator;
		
		//Επιλογή παραλλαγής
		generateVariation();

		sourceSpecialResults="";
        defineWhileLimits(solutionStartVal,solutionEndVal,solutionStepVal,solutionComparator,selectedVariation,comparatorType,"originalResults",sourceCode);

        //Παραγωγή κώδικα
		code+="\n1: <span class='algoCmd' id='cmd1'>x <- "+solutionStartVal+"</span>   <span class='showValues' id='xStart'></span>";
		code+="\n2: <span class='algoCmd' id='cmd2'><span class='reservedWord'>ΟΣΟ</span> x "+solutionWhileComparator+" "+solutionEndVal+" <span class='reservedWord'>ΕΠΑΝΑΛΑΒΕ</span></span>   <span class='showValues' id='xCond'></span>";
		if(selectedVariation==firstUseCounterThenChangeIt){
			solutionCommand1="<span class='algoCmd' id='cmd3'>  <span class='reservedWord'>ΓΡΑΨΕ</span> x </span>   <span class='showValues' id='xOutput'></span>";
			solutionCommand2="<span class='algoCmd' id='cmd4'>  x <- x"+signToShow+Math.abs(solutionStepVal)+" </span>   <span class='showValues' id='xVal'></span>";
			outputIndex=2;
            generateNewValueIndex=3;
		}
		else{
			solutionCommand1="<span class='algoCmd' id='cmd3'>  x <- x"+signToShow+Math.abs(solutionStepVal)+" </span>   <span class='showValues' id='xVal'></span>";
			solutionCommand2="<span class='algoCmd' id='cmd4'>  <span class='reservedWord'>ΓΡΑΨΕ</span> x </span>   <span class='showValues' id='xOutput'></span>";
            generateNewValueIndex=2;
            outputIndex=3;
		}
		code+="\n3: "+solutionCommand1;
		code+="\n4: "+solutionCommand2;
		code+="\n5: <span class='algoCmd' id='cmd5'><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
		sourceCodeLength=5;
		
		if(comparatorType==comparatorWithEquality){
			if(selectedVariation==firstUseCounterThenChangeIt){
				virtualStartVal=solutionStartVal;
				virtualEndVal=solutionEndVal;
			}
			else{
				virtualStartVal=solutionStartVal+Math.sign(solutionStepVal);
				virtualEndVal=solutionEndVal+Math.sign(solutionStepVal);
			}
		}
		else{
			if(selectedVariation==firstUseCounterThenChangeIt){
				virtualStartVal=solutionStartVal;
				virtualEndVal=solutionEndVal-Math.sign(solutionStepVal);
			}
			else{
				virtualStartVal=solutionStartVal+Math.sign(solutionStepVal);
				virtualEndVal=solutionEndVal;
			}
		}
		solutionEndValSpan=Math.abs(virtualEndVal-virtualStartVal) % Math.abs(solutionStepVal);
		if(solutionStepVal>0){
			solutionEndLoLim=virtualEndVal-solutionEndValSpan;
			solutionEndHiLim=solutionEndLoLim+solutionStepVal-1;
		}
		else{
			solutionEndHiLim=virtualEndVal+solutionEndValSpan;
			solutionEndLoLim=solutionEndHiLim+solutionStepVal+1;
		}		
	}
	else{
		code+="\n1: <span class='algoCmd' id='cmdStudent1'>x <- "+generateEntryPlaceholder(-1,"startVal")+"</span>   <span class='showValues' id='xStartStudent'></span>";
		code+="\n2: <span class='algoCmd' id='cmdStudent2'><span class='reservedWord'>ΟΣΟ</span> x "+generateEntryPlaceholder(-1,"comparator_endVal")+" <span class='reservedWord'>ΕΠΑΝΑΛΑΒΕ</span></span>   <span class='showValues' id='xCondStudent'></span>";
		code+="\n3: <span class='algoCmd' id='cmdStudent3'>  "+generateEntryPlaceholder(-1,"command1")+" <span id='command1OfLoop'></span></span>";
		code+="\n4: <span class='algoCmd' id='cmdStudent4'>  "+generateEntryPlaceholder(-1,"command2")+" <span id='command2OfLoop'></span></span>";
		code+="\n5: <span class='algoCmd' id='cmdStudent5'><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
		studentCodeLength=5;
	}
	return code;
}

function generateRepeatLoop(generatorSelector){
	var code="";
	if(generatorSelector==generateFullCode){
		//Βασικές παράμετροι Δ.Ε.
		solutionStartVal=parseInt(Math.random()*100);
		solutionEndVal=parseInt(Math.random()*100);
		while(solutionEndVal==solutionStartVal){
			solutionEndVal=parseInt(Math.random()*100);
		}
		solutionStepVal=Math.sign(solutionEndVal-solutionStartVal)*parseInt(Math.random()*19);

		var signToShow=solutionStepVal>=0?" + ":" - ";
		//Επιλογή αυστηρής ανισότητας ή ανισοϊσότητας
		selectComparator();

		if(solutionEndVal>solutionStartVal){
			if(comparatorType==comparatorWithEquality){
				solutionWhileComparator="<";	
				solutionForComparator="<";
				solutionRepeatComparator=">=";
			}
			else{
				solutionWhileComparator="<=";
				solutionForComparator="<=";
				solutionRepeatComparator=">";
			}
		}
		else{
			if(comparatorType==comparatorWithEquality){
				solutionWhileComparator=">";
				solutionForComparator=">";
				solutionRepeatComparator="<=";
			}
			else{
				solutionWhileComparator=">=";
				solutionForComparator=">=";
				solutionRepeatComparator="<";
			}
		}
		//Επιλογή παραλλαγής
		generateVariation();

		
		//@@@@@@@@@@@@@@@@@@@@@
		if(debug){
			solutionStartVal=1;
			solutionEndVal=10;
			solutionStepVal=-1;
			signToShow=" - ";
			comparatorType=comparatorWithEquality;
			solutionWhileComparator="<";
			solutionForComparator="<";
			solutionRepeatComparator=">=";
		}
		//@@@@@@@@@@@@@@@@@@@@@
		
		sourceSpecialResults="";
        defineRepeatLimits(solutionStartVal,solutionEndVal,solutionStepVal,solutionRepeatComparator,selectedVariation,comparatorType,"originalResults",sourceCode);

        //Παραγωγή κώδικα
		code+="\n1: <span class='algoCmd' id='cmd1'>x <- "+solutionStartVal+"</span>   <span class='showValues' id='xStart'></span>";
		code+="\n2: <span class='algoCmd' id='cmd2'><span class='reservedWord'>ΑΡΧΗ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
		if(selectedVariation==firstUseCounterThenChangeIt){
			solutionCommand1="<span class='algoCmd' id='cmd3'>  <span class='reservedWord'>ΓΡΑΨΕ</span> x </span>   <span class='showValues' id='xOutput'></span>";
			solutionCommand2="<span class='algoCmd' id='cmd4'>  x <- x"+signToShow+Math.abs(solutionStepVal)+" </span>   <span class='showValues' id='xVal'></span>";
			outputIndex=2;
			generateNewValueIndex=3;
		}
		else{
			solutionCommand1="<span class='algoCmd' id='cmd3'>  x <- x"+signToShow+Math.abs(solutionStepVal)+" </span>   <span class='showValues' id='xVal'></span>";
			solutionCommand2="<span class='algoCmd' id='cmd4'>  <span class='reservedWord'>ΓΡΑΨΕ</span> x </span>   <span class='showValues' id='xOutput'></span>";
            generateNewValueIndex=2;
            outputIndex=3;
		}
		code+="\n3: "+solutionCommand1;
		code+="\n4: "+solutionCommand2;
		code+="\n5: <span class='algoCmd' id='cmd5'><span class='reservedWord'>ΜΕΧΡΙΣ_ΟΤΟΥ</span> x "+solutionRepeatComparator+" "+solutionEndVal+"</span>   <span class='showValues' id='xCond'></span>";
		sourceCodeLength=5;
		
		if(comparatorType==comparatorWithEquality){
			if(selectedVariation==firstUseCounterThenChangeIt){
				virtualStartVal=solutionStartVal;
				virtualEndVal=solutionEndVal;
			}
			else{
				virtualStartVal=solutionStartVal+Math.sign(solutionStepVal);
				virtualEndVal=solutionEndVal+Math.sign(solutionStepVal);
			}
		}
		else{
			if(selectedVariation==firstUseCounterThenChangeIt){
				virtualStartVal=solutionStartVal;
				virtualEndVal=solutionEndVal+Math.sign(solutionStepVal);
			}
			else{
				virtualStartVal=solutionStartVal+Math.sign(solutionStepVal);
				virtualEndVal=solutionEndVal+2*Math.sign(solutionStepVal);
			}
		}
		solutionEndValSpan=Math.abs(virtualEndVal-virtualStartVal) % Math.abs(solutionStepVal);
		if(solutionStepVal>0){
			solutionEndLoLim=parseInt((virtualEndVal-1-virtualStartVal)/solutionStepVal)*solutionStepVal+virtualStartVal;
			solutionEndHiLim=solutionEndLoLim+solutionStepVal-1;
		}
		else{
			solutionEndHiLim=parseInt((virtualEndVal+1-virtualStartVal)/solutionStepVal)*solutionStepVal+virtualStartVal;
			solutionEndLoLim=solutionEndHiLim+solutionStepVal+1;
		}
	}
	else{
		code+="\n1: <span class='algoCmd' id='cmdStudent1'>x <- "+generateEntryPlaceholder(-1,"startVal")+"</span>   <span class='showValues' id='xStartStudent'></span>";
		code+="\n2: <span class='algoCmd' id='cmdStudent2'><span class='reservedWord'>ΑΡΧΗ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
		code+="\n3: <span class='algoCmd' id='cmdStudent3'>  "+generateEntryPlaceholder(3,"command1")+" </span><span id='command1OfLoop'></span>";
		code+="\n4: <span class='algoCmd' id='cmdStudent4'>  "+generateEntryPlaceholder(4,"command2")+" </span><span id='command2OfLoop'></span>";
		code+="\n5: <span class='algoCmd' id='cmdStudent5'><span class='reservedWord'>ΜΕΧΡΙΣ_ΟΤΟΥ</span> x "+generateEntryPlaceholder(-1,"comparator_endVal")+"</span>   <span class='showValues' id='xCondStudent'></span>";
		studentCodeLength=5;
	}
	return code;
}

function generateVariation(){
	if (Math.random()<0.5){
		selectedVariation=firstUseCounterThenChangeIt;
	}
	else{
		selectedVariation=firstChangeCounterThenUseIt;
	}
}

function selectComparator(){
	if (Math.random()<0.5){
		comparatorType=comparatorWithEquality;
	}
	else{
		comparatorType=comparatorWithoutEquality;
	}	
}

function storeSpecialResults(results,codeID){
	if(codeID==sourceCode){
		sourceSpecialResults=results;
	}
	else{
		studentSpecialResults=results;
	}
}

function defineForLimits(startVal,endVal,stepVal,valueList,codeID){
	var lowEnd=0,highEnd=0;
	var x;
	var results="";
	x=startVal;
	var repetitionsCounter=0;
	if(stepVal>0){
		for(x=startVal;x<=endVal;x+=stepVal){
			results+=x+valueSeparator;
			repetitionsCounter++;
		}
		lowEnd=x-stepVal;
		highEnd=Math.max(x-1,startVal);
	}
	else if(stepVal<0){
		for(x=startVal;x>=endVal;x+=stepVal){
			results+=x+valueSeparator;
			repetitionsCounter++;
		}
		highEnd=Math.min(x-stepVal,startVal);
		lowEnd=highEnd+stepVal+1;
	}
	else{  //solutionStepVal=0
		if(startVal<endVal){
			lowEnd=startVal;
			highEnd=Infinity;
		}
		else{ //solutionStartVal>solutionEndVal
			highEnd=startVal;
			lowEnd=-Infinity;
		}
		results=startVal+" (άπειρες φορές)";
		storeSpecialResults(results,codeID);
		repetitionsCounter=Infinity;
	}
	if(valueList=="originalResults"){
		startLim=startVal;
		loEndLim=lowEnd;
		hiEndLim=highEnd;
		solutionRepetitionsCounter=repetitionsCounter;
	}
	else{
		userStartLim=startVal;
		userRepetitionsCounter=repetitionsCounter;
	}
	if(results==""){
		results="(καμία επανάληψη)";
		storeSpecialResults(results,codeID);
	}
	//-//*document.getElementById(valueList).innerHTML=results;
	sizeDIVs();
}

function defineRepeatLimits(startVal,endVal,stepVal,comparator,slctdVariation,compType,valueList,codeID){
	var lowEnd=0,highEnd=0;
	var x;
	var results="";
	var repetitionsCounter=0;
	var simulatedCondition=false;
	var endlessLoop=false;
	if(stepVal>0){
		if(startVal+stepVal>=endVal && comparator=="<"){
			endlessLoop=true;
		}
		else if(startVal+stepVal>endVal && comparator=="<="){
			endlessLoop=true;
		}
		if(slctdVariation==firstChangeCounterThenUseIt){
			if(valueList=="originalResults"){
				startLim=startVal+stepVal;
			}
			else{
				userStartLim=startVal+stepVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				do{
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
					if(comparator==">="){
						simulatedCondition=x<endVal;
					}
					else{ //comparator=="<="
						simulatedCondition=x>endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				lowEnd=x;
				highEnd=Math.max(x+stepVal-1,startVal);
			}
			else{ //comparatorWithoutEquality
				do{
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
					if(comparator==">"){
						simulatedCondition=x<=endVal;
					}
					else{ //comparator=="<"
						simulatedCondition=x>=endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				lowEnd=x;
				highEnd=Math.max(x+stepVal-1,startVal);
			}
		}
		else{ //firstUseCounterThenChangeIt
			if(valueList=="originalResults"){
				startLim=startVal;
			}
			else{
				userStartLim=startVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				do{
					results+=x+valueSeparator;
					repetitionsCounter++;
					x+=stepVal;
					if(comparator==">="){
						simulatedCondition=x<endVal;
					}
					else{ //comparator=="<="
						simulatedCondition=x>endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				highEnd=x-1;
				lowEnd=Math.max(x-stepVal,startVal);
			}
			else{ //comparatorWithoutEquality
				do{
					results+=x+valueSeparator;
					repetitionsCounter++;
					x+=stepVal;
					if(comparator==">"){
						simulatedCondition=x<=endVal;
					}
					else{ //comparator=="<"
						simulatedCondition=x>=endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				highEnd=x-1;
				lowEnd=Math.max(x-stepVal,startVal);
			}
		}
	}
	else if(stepVal<0){
		if(startVal+stepVal<=endVal && comparator==">"){
			endlessLoop=true;
		}
		else if(startVal+stepVal<endVal && comparator==">="){
			endlessLoop=true;
		}
		if(slctdVariation==firstChangeCounterThenUseIt){
			if(valueList=="originalResults"){
				startLim=startVal+stepVal;
			}
			else{
				userStartLim=startVal+stepVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				do{
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
					if(comparator==">="){
						simulatedCondition=x<endVal;
					}
					else{ //comparator=="<="
						simulatedCondition=x>endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				highEnd=x;
				lowEnd=Math.min(x+stepVal+1,startVal);
			}
			else{ //comparatorWithoutEquality
				do{
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
					if(comparator==">"){
						simulatedCondition=x<=endVal;
					}
					else{ //comparator=="<"
						simulatedCondition=x>=endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				highEnd=x;
				lowEnd=Math.min(x+stepVal+1,startVal);
			}
		}
		else{ //firstUseCounterThenChangeIt
			if(valueList=="originalResults"){
				startLim=startVal;
			}
			else{
				userStartLim=startVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				do{
					results+=x+valueSeparator;
					repetitionsCounter++;
					x+=stepVal;
					if(comparator==">="){
						simulatedCondition=x<endVal;
					}
					else{ //comparator=="<="
						simulatedCondition=x>endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				lowEnd=x+1;
				highEnd=Math.min(x-stepVal,startVal);
			}
			else{ //comparatorWithoutEquality
				do{
					results+=x+valueSeparator;
					repetitionsCounter++;
					x+=stepVal;
					if(comparator==">"){
						simulatedCondition=x<=endVal;
					}
					else{ //comparator=="<"
						simulatedCondition=x>=endVal;
					}
				}while(simulatedCondition && continueEndlessRepeatLoop(endlessLoop,repetitionsCounter));
				lowEnd=x+1;
				highEnd=Math.min(x-stepVal,startVal);
			}
		}
	}
	else{  //stepVal=0
		if(valueList=="originalResults"){
			startLim=startVal;
		}
		else{
			userStartLim=startVal;
		}
		if(startVal==endVal){
			lowEnd=startVal;
			highEnd=Infinity;
			if(comparator.charAt(0)=="=" || comparator.length>1 && comparator.charAt(1)=="="){
				results=startVal;
				repetitionsCounter=1;
			}
			else{ //comparator==">" ή comparator=="<"
				results=startVal+" (άπειρες φορές)";
				storeSpecialResults(results,codeID);
				repetitionsCounter=Infinity;
			}
		}
		else if(startVal<endVal){
			lowEnd=startVal;
			highEnd=Infinity;
			if(comparator.charAt(0)==">"){
				results=startVal+" (άπειρες φορές)";
				storeSpecialResults(results,codeID);
				repetitionsCounter=Infinity;
			}
			else{
				results=startVal;
				repetitionsCounter=1;
			}
		}
		else{ //startVal>endVal
			highEnd=startVal;
			lowEnd=-Infinity;
			if(comparator.charAt(0)=="<"){
				results=startVal+" (άπειρες φορές)";
				storeSpecialResults(results,codeID);
				repetitionsCounter=Infinity;
			}
			else{
				results=startVal;
				repetitionsCounter=1;
				storeSpecialResults(results,codeID);
			}
		}
	}
	if(valueList=="originalResults"){
		loEndLim=lowEnd;
		hiEndLim=highEnd;
		solutionRepetitionsCounter=repetitionsCounter;
	}
	else{
		userRepetitionsCounter=repetitionsCounter;
	}
	if(endlessLoop){
		results+=" ... (άπειρες τιμές)";
		storeSpecialResults(results,codeID);
		repetitionsCounter=Infinity;
		lowEnd=Math.sign(stepVal)*Infinity;
		highEnd=Math.sign(stepVal)*Infinity;
	}
	if(results==""){
		results="(καμία επανάληψη)";
		storeSpecialResults(results,codeID);
	}
	//-//*document.getElementById(valueList).innerHTML=results;
	sizeDIVs();
}

function defineWhileLimits(startVal,endVal,stepVal,comparator,slctdVariation,compType,valueList,codeID){
	var lowEnd=0,highEnd=0;
	var x;
	var results="";
	var repetitionsCounter=0;
	//var simulatedCondition=false;
	var endlessLoop=false;
	if(stepVal>0){
		if(startVal>endVal && comparator==">"){
			endlessLoop=true;
		}
		else if(startVal>=endVal && comparator==">="){
			endlessLoop=true;
		}
		if(slctdVariation==firstChangeCounterThenUseIt){
			if(valueList=="originalResults"){
				startLim=startVal+stepVal;
			}
			else{
				userStartLim=startVal+stepVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				while(x<=endVal && comparator=="<=" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
				}
				lowEnd=x;
				highEnd=Math.max(x+stepVal-1,startVal);
			}
			else{ //comparatorWithoutEquality
				while(x<endVal && comparator=="<" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
				}
				highEnd=x+stepVal-1;
				lowEnd=Math.max(x,startVal);
			}
		}
		else{ //firstUseCounterThenChangeIt
			if(valueList=="originalResults"){
				startLim=startVal;
			}
			else{
				userStartLim=startVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				while(x<=endVal && comparator=="<=" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					results+=x+valueSeparator;
					x+=stepVal;
					repetitionsCounter++;
				}
				lowEnd=x-stepVal;
				highEnd=Math.max(x-1,startVal);
			}
			else{ //comparatorWithoutEquality
				while(x<endVal && comparator=="<" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					results+=x+valueSeparator;
					x+=stepVal;
					repetitionsCounter++;
				}
				highEnd=x-1;
				lowEnd=Math.max(x-stepVal,startVal);
			}
		}
	}
	else if(stepVal<0){
		if(startVal<=endVal && comparator=="<="){
			endlessLoop=true;
		}
		else if(startVal<endVal && comparator=="<"){
			endlessLoop=true;
		}
		if(slctdVariation==firstChangeCounterThenUseIt){
			if(valueList=="originalResults"){
				startLim=startVal+stepVal;
			}
			else{
				userStartLim=startVal+stepVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				while(x>=endVal && comparator==">=" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
				}
				highEnd=x;
				lowEnd=Math.min(x+stepVal+1,startVal);
			}
			else{ //comparatorWithoutEquality
				while(x>endVal && comparator==">" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					x+=stepVal;
					results+=x+valueSeparator;
					repetitionsCounter++;
				}
				highEnd=x;
				lowEnd=Math.min(x+stepVal+1,startVal);
			}
		}
		else{ //firstUseCounterThenChangeIt
			if(valueList=="originalResults"){
				startLim=startVal;
			}
			else{
				userStartLim=startVal;
			}
			x=startVal;
			if(compType==comparatorWithEquality){
				while(x>=endVal && comparator==">=" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					results+=x+valueSeparator;
					repetitionsCounter++;
					x+=stepVal;
				}
				lowEnd=x+1;
				highEnd=Math.min(x-stepVal,startVal);
			}
			else{ //comparatorWithoutEquality
				while(x>endVal && comparator==">" || continueEndlessWhileLoop(endlessLoop,repetitionsCounter)){
					results+=x+valueSeparator;
					repetitionsCounter++;
					x+=stepVal;
				}
				lowEnd=x+1;
				highEnd=Math.min(x-stepVal,startVal);
			}
		}
	}
	else{//stepVal=0
		if(valueList=="originalResults"){
			startLim=startVal;
		}
		else{
			userStartLim=startVal;
		}
		if(startVal==endVal){
			if(comparator=="=" || comparator.length>1 && comparator.charAt(1)=="="){// = ή >= ή <=
				results=startVal+" (άπειρες φορές)";
				repetitionsCounter=Infinity;
				storeSpecialResults(results,codeID);
			}
			else if(comparator==">" || comparator=="<" || comparator=="<>"){
				results="(καμία επανάληψη)";
				repetitionsCounter=0;
				storeSpecialResults(results,codeID);
			}
		}
		else if(startVal<endVal){
			if(comparator.charAt(0)=="<"){// < ή <= ή <>
				results=startVal+" (άπειρες φορές)";
				repetitionsCounter=Infinity;
				storeSpecialResults(results,codeID);
			}
			else if(comparator.charAt(0)==">" || comparator=="="){// > ή >= ή =
				results="(καμία επανάληψη)";
				repetitionsCounter=0;
				storeSpecialResults(results,codeID);
			}
		}
		else{ //startVal>endVal
			if(comparator.charAt(0)==">" || comparator=="<>"){// > ή >= ή <>
				results=startVal+" (άπειρες φορές)";
				repetitionsCounter=Infinity;
				storeSpecialResults(results,codeID);
			}
			else if(comparator=="=" || comparator.charAt(0)=="<"){// = ή < ή <=
				results="(καμία επανάληψη)";
				repetitionsCounter=0;
				storeSpecialResults(results,codeID);
			}
		}
		if(comparator=="="){
			lowEnd=startVal;
			highEnd=startVal;
		}
		else if(comparator=="<>"){
			lowEnd=-Infinity;
			highEnd=Infinity;
			showUnion=true;
		}
		else if(comparator=="<"){
			lowEnd=startVal+1;
			highEnd=Infinity;
		}
		else if(comparator=="<="){
			lowEnd=startVal;
			highEnd=Infinity;
		}
		else if(comparator==">"){
			lowEnd=-Infinity;
			highEnd=startVal-1;
		}
		else if(comparator==">="){
			lowEnd=-Infinity;
			highEnd=startVal;
		}


	}
	if(valueList=="originalResults"){
		loEndLim=lowEnd;
		hiEndLim=highEnd;
		solutionRepetitionsCounter=repetitionsCounter;
	}
	else{
		userRepetitionsCounter=repetitionsCounter;
	}
	if(endlessLoop){
		results+=" ... (άπειρες τιμές)";
		storeSpecialResults(results,codeID);
		repetitionsCounter=Infinity;
		lowEnd=Math.sign(stepVal)*Infinity;
		highEnd=Math.sign(stepVal)*Infinity;
	}
	if(results==""){
		results="(καμία επανάληψη)";
		storeSpecialResults(results,codeID);
	}
	//-//*.getElementById(valueList).innerHTML=results;
	sizeDIVs();
}

function continueEndlessWhileLoop(endlessLoop,repetitionsCounter){
	return (endlessLoop && repetitionsCounter<endlessLoopMaxReps);
}

function continueEndlessRepeatLoop(endlessLoop,repetitionsCounter){
	return !(endlessLoop && repetitionsCounter==endlessLoopMaxReps);
}

function checkSolution(){
	$("#solutionOk").hide();
	$("#solutionError").hide();
	userOutputVisible=false;
	$("#studentResults").html("");
	sizeDIVs();
	if(userSolutionOK()){
		///alert("Εύγε!!!!");
		$("#btnHint").prop("disabled",true);
		
		$("#solutionOk").show(jQueryAnimationRate);
	}
	else{
		$("#solutionError").show(jQueryAnimationRate);
		/*var msg="Την πάτησες...";
		if(document.getElementById("originalResults").innerHTML==document.getElementById("studentResults").innerHTML){
			msg+="Η δική σου Δ.Ε. εμφανίζει τα ίδια αποτελέσματα με την αρχική,";
			msg+="αλλά η τελική τιμή της μεταβλητής x, μετά την έξοδο από τη Δομή, διαφέρει.";
		}
		alert(msg);*/
		$("#btnHint").prop("disabled",false);
	}
}

function userSolutionOK(){
	var solutionOK=true;
	clearHint();
	//έλεγχος εγκυρότητας και εξαγωγή τιμών χρήστη
	solutionOK=checkUserEntries();
	if(!solutionOK) return false;
	switch(exerciseType){
	case for2While:
	case repeat2While:
		if(!isNaN(userStartVal) && !isNaN(userEndVal) && !isNaN(userStepVal)){

			studentSpecialResults="";
			defineWhileLimits(userStartVal,userEndVal,userStepVal,userComparator,userSolutionVariation,userComparatorType,"studentResults",studentCode);

		}
		if(userComparatorType==comparatorWithEquality){
			hintLoEndLim=loEndLim;
			hintHiEndLim=hiEndLim;
		}
		else{
			hintLoEndLim=loEndLim+Math.sign(userStepVal);
			hintHiEndLim=hiEndLim+Math.sign(userStepVal);
		}		
		//έλεγχος ορθότητας τιμών χρήστη
		var userStartValToCheck,userEndValToCheck;
		if(userSolutionVariation==firstUseCounterThenChangeIt){
			userStartValToCheck=userStartVal;
			userEndValToCheck=userEndVal;
		}
		else{
			userStartValToCheck=userStartVal+userStepVal;
			userEndValToCheck=userEndVal+userStepVal;
		}
		solutionOK=solutionOK && (trimSpaces(startLim.toString()).toLowerCase()==userStartValToCheck);
		var stepsDifference=0;
		if(solutionRepetitionsCounter==1){
			
			var absSolutionStepVal=Math.abs(parseFloat(trimSpaces(solutionStepVal.toString()).toLowerCase()));
			stepsDifference=Math.abs(userStepVal)-absSolutionStepVal;
			// Η επόμενη γραμμή δε βγάζει σωστό αποτέλεσμα όταν userStepVal<SolutionStepVal  
			//solutionOK=solutionOK && (stepsDifference>=0);
			
			solutionOK=solutionOK && userRepetitionsCounter==1; // σωστό ως προς τις εμφανιζόμενες τιμές, αλλά όχι ως προς την τιμή του x μετά την έξοδο από την επανάληψη
		}
		else{
			solutionOK=solutionOK && (trimSpaces(solutionStepVal.toString()).toLowerCase()==userStepVal);
			if(userStepVal>0){
				if(userComparatorType==comparatorWithEquality){
					solutionOK=solutionOK && (loEndLim<=userEndValToCheck && userEndValToCheck<=hiEndLim+stepsDifference);
					/*hintLoEndLim=loEndLim;
					hintHiEndLim=hiEndLim+stepsDifference;*/

				}
				else{ //comparatorWithoutEquality
					solutionOK=solutionOK && (loEndLim<userEndValToCheck && userEndValToCheck<=hiEndLim+1+stepsDifference);
					/*hintLoEndLim=loEndLim+1;
					hintHiEndLim=hiEndLim+1+stepsDifference;*/
				}
			}
			else if(userStepVal<0){
				if(userComparatorType==comparatorWithEquality){
					solutionOK=solutionOK && (loEndLim-stepsDifference<=userEndValToCheck && userEndValToCheck<=hiEndLim);
					/*hintLoEndLim=loEndLim-stepsDifference;
					hintHiEndLim=hiEndLim;*/
				}
				else{ //comparatorWithoutEquality
					solutionOK=solutionOK && (loEndLim-1-stepsDifference<=userEndValToCheck && userEndValToCheck<hiEndLim);							
					/*hintLoEndLim=loEndLim-1-stepsDifference;
					hintHiEndLim=hiEndLim-1;*/
				}
			}
			else{ //Αν το βήμα είναι μηδέν τα όρια δεν παίζουν ρόλο
				solutionOK=solutionOK && userRepetitionsCounter==solutionRepetitionsCounter;
				if(userComparatorType==comparatorWithoutEquality){
					if(userComparator==">"){
						hintLoEndLim=loEndLim-1;
					}
					else if(userComparator=="<"){
						hintLoEndLim=loEndLim+1;
					}
				}		
			}  
		}
		solutionOK=solutionOK && solutionRepetitionsCounter==userRepetitionsCounter;
		break;
	case for2Repeat:
	case while2Repeat:
		if(!isNaN(userStartVal) && !isNaN(userEndVal) && !isNaN(userStepVal)){

			studentSpecialResults="";
			defineRepeatLimits(userStartVal,userEndVal,userStepVal,userComparator,userSolutionVariation,userComparatorType,"studentResults",studentCode);

		}
		//έλεγχος ορθότητας τιμών χρήστη
		var userStartValToCheck,userEndValToCheck;
		if(userSolutionVariation==firstUseCounterThenChangeIt){
			userStartValToCheck=userStartVal;
			userEndValToCheck=userEndVal;
		}
		else{
			userStartValToCheck=userStartVal+userStepVal;
			userEndValToCheck=userEndVal+userStepVal;
		}
		solutionOK=solutionOK && (trimSpaces(startLim.toString()).toLowerCase()==userStartValToCheck);
		var stepsDifference=0;
		if(solutionRepetitionsCounter==1){
			
			var absSolutionStepVal=Math.abs(parseFloat(trimSpaces(solutionStepVal.toString()).toLowerCase()));
			stepsDifference=Math.abs(userStepVal)-absSolutionStepVal;
			// Η επόμενη γραμμή δε βγάζει σωστό αποτέλεσμα όταν userStepVal<SolutionStepVal  
			//solutionOK=solutionOK && (stepsDifference>=0);
			
			solutionOK=solutionOK && userRepetitionsCounter==1; // σωστό ως προς τις εμφανιζόμενες τιμές, αλλά όχι ως προς την τιμή του x μετά την έξοδο από την επανάληψη 
		}
		else{
			solutionOK=solutionOK && (trimSpaces(solutionStepVal.toString()).toLowerCase()==userStepVal);
			if(userStepVal>0){
				if(userComparatorType==comparatorWithEquality){
					solutionOK=solutionOK && (loEndLim<userEndValToCheck && userEndValToCheck<=hiEndLim+1+stepsDifference);
					/*hintLoEndLim=loEndLim+1;
					hintHiEndLim=hiEndLim+1+stepsDifference;*/
				}
				else{ //comparatorWithoutEquality
					solutionOK=solutionOK && (loEndLim<=userEndValToCheck && userEndValToCheck<hiEndLim+1+stepsDifference);
					/*hintLoEndLim=loEndLim;
					hintHiEndLim=hiEndLim+stepsDifference;*/
				}
			}
			else if(userStepVal<0){
				if(userComparatorType==comparatorWithEquality){
					solutionOK=solutionOK && (loEndLim-1-stepsDifference<=userEndValToCheck && userEndValToCheck<hiEndLim);
					/*hintLoEndLim=loEndLim-1-stepsDifference;
					hintHiEndLim=hiEndLim-1;*/

				}
				else{ //comparatorWithoutEquality
					solutionOK=solutionOK && (loEndLim-stepsDifference<=userEndValToCheck && userEndValToCheck<=hiEndLim);
					/*hintLoEndLim=loEndLim-stepsDifference;
					hintHiEndLim=hiEndLim;*/
				}
			}
			else{ //Αν το βήμα είναι μηδέν τα όρια δεν παίζουν ρόλο
			  solutionOK=solutionOK && userRepetitionsCounter==solutionRepetitionsCounter;
			}
		}
		solutionOK=solutionOK && solutionRepetitionsCounter==userRepetitionsCounter; 
		if(userComparatorType==comparatorWithEquality){
			hintLoEndLim=loEndLim+Math.sign(userStepVal);
			hintHiEndLim=hiEndLim;
		}
		else{
			hintLoEndLim=loEndLim;
			hintHiEndLim=hiEndLim;
		}
		break;
	case while2For:
	case repeat2For:
		if(!isNaN(userStartVal) && !isNaN(userEndVal) && !isNaN(userStepVal)){
			
			studentSpecialResults="";
			defineForLimits(userStartVal,userEndVal,userStepVal,"studentResults",studentCode);
		}
		//έλεγχος ορθότητας τιμών χρήστη
		solutionOK=solutionOK && (trimSpaces(startLim.toString()).toLowerCase()==userStartVal);
		var stepsDifference=0;
		if(solutionRepetitionsCounter==1){
			
			var absSolutionStepVal=Math.abs(parseFloat(trimSpaces(solutionStepVal.toString()).toLowerCase()));
			stepsDifference=Math.abs(userStepVal)-absSolutionStepVal;
			// Η επόμενη γραμμή δε βγάζει σωστό αποτέλεσμα όταν userStepVal<SolutionStepVal  
			//solutionOK=solutionOK && (stepsDifference>=0);
			
			solutionOK=solutionOK && userRepetitionsCounter==1; // σωστό ως προς τις εμφανιζόμενες τιμές, αλλά όχι ως προς την τιμή του x μετά την έξοδο από την επανάληψη
		}
		else{
			solutionOK=solutionOK && (trimSpaces(solutionStepVal.toString()).toLowerCase()==userStepVal);
			if(userStepVal>0){
				solutionOK=solutionOK && (loEndLim<=userEndVal && userEndVal<=hiEndLim+stepsDifference);
				/*hintLoEndLim=loEndLim;
				hintHiEndLim=hiEndLim+stepsDifference;*/
			}
			else if(userStepVal<0){
				solutionOK=solutionOK && (loEndLim-stepsDifference<=userEndVal && userEndVal<=hiEndLim);
				/*hintLoEndLim=loEndLim-stepsDifference;
				hintHiEndLim=hiEndLim;*/
			}
			/*
			else{ //Αν το βήμα είναι μηδέν τα όρια δεν παίζουν ρόλο
			  solutionOK=true; //Ισχύει ήδη, οπότε η εντολή περιττεύει
			}  
			*/
		}
		solutionOK=solutionOK && solutionRepetitionsCounter==userRepetitionsCounter; 
		hintLoEndLim=loEndLim;
		hintHiEndLim=hiEndLim;
		break;
	}
	/*if(debug){
		var sln=solutionStartVal+":"+userStartVal;
		sln+=" "+solutionComparator_endVal+":"+userComparator_endVal;
		sln+=" "+solutionCommand1+":"+userCommand1;
		sln+=" "+solutionCommand2+":"+userCommand2;
		alert(sln);

		var msg="StartVal:"+trimSpaces(solutionStartVal.toString()).toLowerCase()+" "+userStartVal;
		//msg+="\nsolutionEndValToCheck:"+trimSpaces(solutionEndValToCheck.toString()).toLowerCase();
		msg+="\nEndVal:"+userEndVal;
		msg+="\nStepVal:"+trimSpaces(solutionStepVal.toString()).toLowerCase()+" "+userStepVal;
		msg+="\nstartLim:"+startLim;
		msg+="\nloEndLim:"+loEndLim;
		msg+="\nhiEndLim:"+hiEndLim;
		alert(msg);
	}*/
	return solutionOK;
}

function checkUserEntries(){
	errorLocation=noSyntaxError;
	var entriesOK=true;
	//1. Τιμή Έναρξης
	userStartVal=trimSpaces(document.getElementById("startVal").textContent.toLowerCase());
	entriesOK=entriesOK && checkEntry(userStartVal,numericEntry);
	if(!entriesOK) {
		errorLocation=startValError;
		return false;
	}
	userStartVal=parseFloat(userStartVal);
	//2. Τιμή Λήξης
	if(document.getElementById("endVal")){
		userEndVal=trimSpaces(document.getElementById("endVal").textContent.toLowerCase());
		entriesOK=entriesOK && checkEntry(userEndVal,numericEntry);
		if(!entriesOK) {
			errorLocation=endValError;
			return false;
		}
		userEndVal=parseFloat(userEndVal);
	}
	//3. Τιμή Βήματος
	if(document.getElementById("stepVal")){
		userStepVal=trimSpaces(document.getElementById("stepVal").textContent.toLowerCase());
		entriesOK=entriesOK && checkEntry(userStepVal,numericEntry);
		if(!entriesOK) {
			errorLocation=stepValError;
			return false;
		}
		userStepVal=parseFloat(userStepVal);
	}
	//4. Συγκριτικός Τελεστής και Τιμή Λήξης
	if(document.getElementById("comparator_endVal")){
		userComparator_endVal=trimSpaces(document.getElementById("comparator_endVal").textContent.toLowerCase());
		userComparator="";//θα πάρει τιμή μέσα στην checkEntry
		userComparatorType=comparatorWithoutEquality;
		entriesOK=entriesOK && checkEntry(userComparator_endVal,numericEntry+comparatorEntry) && userComparator!="";
		if(!entriesOK){
			errorLocation=comparatorError;
			return false;
		}
		//Αποκοπή τιμής τερματισμού
		userEndVal=userComparator_endVal.substr(userComparator.length,userComparator_endVal.length-userComparator.length);
		//Έλεγχος ορθότητας τιμής τερματισμού
		userEndVal=trimSpaces(userEndVal.toLowerCase());
		entriesOK=entriesOK && checkEntry(userEndVal,numericEntry);
		if(!entriesOK){
			errorLocation=endValError;
			return false;
		}
		userEndVal=parseFloat(userEndVal);
	}
	//5. εντολή command1
	if(document.getElementById("command1")){
		userCommand1=trimSpaces(document.getElementById("command1").textContent.toLowerCase());
		if(userCommand1.substr(0,5)=="γραψε" || userCommand1.substr(0,5)=="γράψε"){
			if(userCommand1.length==6 && (userCommand1.substr(5,1)=="x" || userCommand1.substr(5,1)=="χ")){
				//τα 'χ' και 'x' είναι αποδεκτά
				userSolutionVariation=firstUseCounterThenChangeIt;
			}
			else{
				errorLocation=outputError;
				return false;
			}
		}
		else if(userCommand1.substr(0,4)=="x<-x" || userCommand1.substr(0,4)=="χ<-χ"){
			//τα 'χ' και 'x' είναι αποδεκτά
			userStepVal=userCommand1.substr(4,userCommand1.length-4);
			entriesOK=entriesOK && checkEntry(userStepVal,numericEntry);
			if(!entriesOK){
				errorLocation=stepValError;
				return false;
			}
			userStepVal=parseFloat(userStepVal);
			userSolutionVariation=firstChangeCounterThenUseIt;
		}
		else{
			errorLocation=loopBodyError;
			return false;
		}
	}
	//6. εντολή command2
	if(document.getElementById("command2")){
		userCommand2=trimSpaces(document.getElementById("command2").textContent.toLowerCase());
		if(userSolutionVariation==firstChangeCounterThenUseIt){
			if(userCommand2.substr(0,5)=="γραψε" || userCommand2.substr(0,5)=="γράψε"){
				if(userCommand2.length==6 && (userCommand2.substr(5,1)=="x" || userCommand2.substr(5,1)=="χ")){
					//τα 'χ' και 'x' είναι αποδεκτά
				}
				else{
					errorLocation=outputError;
					return false;
				}
			}
			else{
				errorLocation=outputError;
				return false;
			}
		}
		else if(userSolutionVariation==firstUseCounterThenChangeIt && userCommand2.substr(0,4)=="x<-x" || userCommand2.substr(0,4)=="χ<-χ"){
			//τα 'χ' και 'x' είναι αποδεκτά
			userStepVal=userCommand2.substr(4,userCommand2.length-4);
			entriesOK=entriesOK && userStepVal.length>1 && checkEntry(userStepVal,numericEntry);
			if(!entriesOK){
				errorLocation=stepValError;
				return false;
			}
			userStepVal=parseFloat(userStepVal);
		}
		else{
			errorLocation=loopBodyError;
			return false;
		}
	}
	return entriesOK;
}

function checkEntry(userEntry,entryType){
	var comparatorPosition=-1;
	var entryOK=true;
	var lessThanAllowed=true;
	var greaterThanAllowed=true;
	var equalAllowed=true;
	var lng=userEntry.length;
	var i=0;
	if(lng==0)entryOK=false;
	while(entryOK && i<lng){
		currentChar=userEntry.charAt(i);
		if((entryType & numericEntry)!=0){//Έλεγχος αριθμητικών ψηφίων
			if(currentChar>="0" && currentChar<="9" || currentChar=="+" || currentChar=="-"){//αριθμητικά ψηφία και πρόσημα είναι δεκτά
				if((entryType & comparatorEntry)!=0){//Ο συγκριτικός τελεστής πρέπει να ολοκληρώνεται πριν την αριθμητική τιμή
					entryType-=comparatorEntry;
				}
			}
			else if(entryType==numericEntry){//οποιοσδήποτε άλλος χαρακτήρας απορρίπτεται εφόσον αναζητούμε μόνο αριθμό
				entryOK=false;
			}
		}
		if(entryOK && (entryType & comparatorEntry)!=0){//Έλεγχος συγκριτικών τελεστών
			if(i==comparatorPosition+1){//Συγκριτικοί Τελεστές επιτρέπονται μόνο σε διαδοχικές αρχικές θέσεις
				comparatorPosition=i;
				switch(currentChar){
				case "<":
					if(lessThanAllowed){
						userComparator+=currentChar;
						lessThanAllowed=false;
					}
					else{
						entryOK=false;
					}
					break;
				case "=":
					if(equalAllowed){
						userComparatorType=comparatorWithEquality;
						userComparator+=currentChar;
						lessThanAllowed=false;
						greaterThanAllowed=false;
						equalAllowed=false;
					}
					else{
						entryOK=false;
					}
					break;
				case ">":
					if(greaterThanAllowed){
						userComparator+=currentChar;
						lessThanAllowed=false;
						greaterThanAllowed=false;
					}
					else{
						entryOK=false;
					}
					break;//επιτρέπονται σύμβολα συγκριτικών χαρακτήρων της ψευδογλώσσας
				default://οποιοσδήποτε άλλος χαρακτήρας απορρίπτεται
					entryOK=false;
				}
			}
			else{
				entryOK=false;
			}
		}
		/*if(entryOK && entryType==textEntry){//Έλεγχος αλφαβητικών χαρακτήρων
			if(currentChar>="α" && currentChar<="ω" || currentChar=="x"){
				//επιτρέπονται ελληνικά πεζά και το λατινικό x
			}
			else{
				entryOK=false;
			}
		}*/
		i++;
	}
	return entryOK;
}

function trimSpaces(entry){
	var currentChar="",correctedChar="";
	var entryLength=entry.length;
	var trimmed="";
	for(var i=0;i<entryLength;i++){
		currentChar=entry.charAt(i);
		if(currentChar!=" " && currentChar!="ˍ"){
			switch(currentChar){
			case "΅":
				correctedChar="";
				break;
			case "Ά":
			case "ά":
				correctedChar="α";
				break;
			case "Έ":
			case "έ":
				correctedChar="ε";
				break;
			case "Ή":
			case "ή":
				correctedChar="η";
				break;
			case "Ί":
			case "ί":
			case "Ϊ":
			case "ϊ":
			case "ΐ":
				correctedChar="ι";
				break;
			case "Ύ":
			case "ύ":
			case "Ϋ":
			case "ϋ":
			case "ΰ":
				correctedChar="υ";
				break;
			case "Ώ":
			case "ώ":
				correctedChar="ω";
				break;
			case "Ό":
			case "ό":
				correctedChar="ο";
				break;
			case "Χ":
			case "χ":
				correctedChar="x";
				break;
			default:
				correctedChar=currentChar.toLowerCase();
			}
			trimmed+=correctedChar;
		}
	}
	return trimmed;
}

function deleteAll(){
	$("#btnHint").prop("disabled",true);
	switch(exerciseType){
	case for2While:
	case repeat2While:
	case for2Repeat:
	case while2Repeat:
		//διαγραφή τιμών χρήστη
		document.getElementById("startVal").innerHTML="ˍˍˍ";
		document.getElementById("comparator_endVal").innerHTML="ˍˍˍ";
		document.getElementById("command1").innerHTML="ˍˍˍ";
		document.getElementById("command2").innerHTML="ˍˍˍ";
		break;
	case while2For:
	case repeat2For:
		//διαγραφή τιμών χρήστη
		document.getElementById("startVal").innerHTML="ˍˍˍ";
		document.getElementById("endVal").innerHTML="ˍˍˍ";
		document.getElementById("stepVal").innerHTML="ˍˍˍ";
		break;
	}
	$("#btnHint").prop("disabled",true);
	$("#solutionOk").hide(jQueryAnimationRate);
	$("#solutionError").hide(jQueryAnimationRate);
	solutionOutputVisible=false;
	//*//$("#originalResults").hide();
	userOutputVisible=false;
	$("#studentResults").html("");
	clearHint();
	hideResult();
	sizeDIVs();
}

function showHint(){
	var msg="";
	switch (errorLocation){
	case startValError:
		msg="Συντακτικό λάθος στην αρχική τιμή.";
		break;
	case endValError:
		msg="Συντακτικό λάθος στην τελική τιμή.";
		break;
	case stepValError:
		msg="Συντακτικό λάθος στην τιμή βήματος μεταβολής.";
		break;
	case comparatorError:
		msg="Συντακτικό λάθος στο συγκριτικό τελεστή.";
		break;
	case outputError:
		msg="Συντακτικό λάθος στην εντολή εξόδου.";
		break;
	case loopBodyError:
		msg="Συντακτικό λάθος στο εσωτερικό της δομής επανάληψης";
		break;
	case noSyntaxError: //δηλαδή λογικό σφάλμα
		if(startLim!=userStartLim){
		    var startValToPresent=solutionStartVal; 
		    if(selectedVariation==firstChangeCounterThenUseIt){
		        startValToPresent=solutionStartVal+solutionStepVal; 
		    }
			msg="<p>Η τιμή έναρξης θα έπρεπε να είναι <span class='correctValue'>"+(startValToPresent)+"</span> αντί <span class='errorValue'>"+userStartVal+"</span>.</p>";
		}
		if(solutionEndVal!=userEndVal || solutionRepetitionsCounter!=userRepetitionsCounter && startLim==userStartLim){
			var limitsToShow="";
			if(loEndLim==hiEndLim){
				limitsToShow="είναι <span class='correctValue'>"+solutionEndVal+"</span>";
			}
			else{
				var hintLoEndLimToShow=infinitySymbol(hintLoEndLim);
				var hintHiEndLimToShow=infinitySymbol(hintHiEndLim);
				if(showUnion){
					limitsToShow="κυμαίνεται στο διάστημα [<span class='correctValue'>"+hintLoEndLimToShow+"</span> , <span class='correctValue'>"+userStartVal+"</span>) &cup; (<span class='correctValue'>"+userStartVal+"</span> , <span class='correctValue'>"+hintHiEndLimToShow+"</span>]";
					
				}
				else{
					limitsToShow="κυμαίνεται στο διάστημα [<span class='correctValue'>"+hintLoEndLimToShow+"</span> , <span class='correctValue'>"+hintHiEndLimToShow+"</span>]";
				}
			}
			msg+="<p>Η τιμή τερματισμού θα έπρεπε να "+limitsToShow+" αντί <span class='errorValue'>"+userEndVal+"</span>.</p>";
		}
		if(solutionStepVal!=userStepVal){
			msg+="Η τιμή του βήματος μεταβολής θα έπρεπε να είναι <span class='correctValue'>"+solutionStepVal+"</span> αντί <span class='errorValue'>"+userStepVal+"</span>.";
		}
		hideHint();
		break;
	}
	document.getElementById("hintToShow").innerHTML=msg;
    $("#resultsArea").hide();
    $("#messageArea").show();
}

function infinitySymbol(value){
	if(value==Infinity){
		return "∞";
	}
	else if(value==-Infinity){
		return "-∞";
	}
	else{
		return value;
	}
}

function clearHint(){
	document.getElementById("hintToShow").innerHTML="";
	showUnion=false;
}

function hideHint(){
	$("#btnHint").prop("disabled",true);
}

function hideResult(){
	$("#solutionOk").hide(jQueryAnimationRate);
	$("#solutionError").hide(jQueryAnimationRate);
}

function showSolution(){
    if(requestConfirmationState || confirm("Θέλεις σίγουρα να αποκαλύψεις μία λύση;")){
    	var stepSign=solutionStepVal>=0?"+":"-";
    	switch(exerciseType){
    	case for2While:
    	case repeat2While:
    		document.getElementById("startVal").innerHTML=solutionStartVal;
    		document.getElementById("comparator_endVal").innerHTML=solutionWhileComparator+solutionEndVal;
    		if(selectedVariation==firstUseCounterThenChangeIt){
    			document.getElementById("command1").innerHTML="<span class='reservedWord'>ΓΡΑΨΕ</span> x";
    			$("#command1OfLoop").html("   <span class='showValues' id='xOutputStudent'></span>");
    			document.getElementById("command2").innerHTML="x <- x "+stepSign+" "+Math.abs(solutionStepVal);
    			$("#command2OfLoop").html("   <span class='showValues' id='xValStudent'></span>");
    		}
    		else{
    			document.getElementById("command1").innerHTML="x <- x "+stepSign+" "+Math.abs(solutionStepVal);
    			$("#command1OfLoop").html("   <span class='showValues' id='xValStudent'></span>");
    			document.getElementById("command2").innerHTML="<span class='reservedWord'>ΓΡΑΨΕ</span> x";
    			$("#command2OfLoop").html("   <span class='showValues' id='xOutputStudent'></span>");
    		}
    		break;
    	case for2Repeat:
    	case while2Repeat:
    		document.getElementById("startVal").innerHTML=solutionStartVal;
    		document.getElementById("comparator_endVal").innerHTML=solutionRepeatComparator+solutionEndVal;
    		if(selectedVariation==firstUseCounterThenChangeIt){
    			document.getElementById("command1").innerHTML="<span class='reservedWord'>ΓΡΑΨΕ</span> x";
    			$("#command1OfLoop").html("   <span class='showValues' id='xOutputStudent'></span>");
    			document.getElementById("command2").innerHTML="x <- x "+stepSign+" "+Math.abs(solutionStepVal);
    			$("#command2OfLoop").html("   <span class='showValues' id='xValStudent'></span>");
    		}
    		else{
    			document.getElementById("command1").innerHTML="x <- x "+stepSign+" "+Math.abs(solutionStepVal);
    			$("#command1OfLoop").html("   <span class='showValues' id='xValStudent'></span>");
    			document.getElementById("command2").innerHTML="<span class='reservedWord'>ΓΡΑΨΕ</span> x";
    			$("#command2OfLoop").html("   <span class='showValues' id='xOutputStudent'></span>");
    		}
    		break;
    	case while2For:
    	case repeat2For:
    		//αποθήκευση τιμών χρήστη
    	    if(selectedVariation==firstUseCounterThenChangeIt){
                document.getElementById("startVal").innerHTML=solutionStartVal;
                document.getElementById("endVal").innerHTML=getSolutionEndVal();
                document.getElementById("stepVal").innerHTML=solutionStepVal;
    	    }
    	    else{
                document.getElementById("startVal").innerHTML=solutionStartVal+solutionStepVal;
                document.getElementById("endVal").innerHTML=getSolutionEndVal();
                document.getElementById("stepVal").innerHTML=solutionStepVal;
    	    }
    		break;
    	}
    	$("#btnHint").prop("disabled",true);
    	/*$("#solutionOk").hide(jQueryAnimationRate);
    	$("#solutionError").hide(jQueryAnimationRate);*/
    	solutionOutputVisible=false;
    	//$("#originalResults").html("");
    	userOutputVisible=false;
    	$("#studentResults").html("");
    	clearHint();
    	hideResult();
    	hideSimulationValues();
    	sizeDIVs();
    }
}

function getSolutionEndVal(){
    var selectedEndVal;
    if(Math.abs(loEndLim)==Infinity || Math.abs(hiEndLim)==Infinity){
        selectedEndVal=parseInt((Math.random()-0.5)*10000);
    }
    else{
        selectedEndVal=parseInt((hiEndLim-loEndLim)*Math.random())+loEndLim;
    }
    return selectedEndVal;
}

function showAppID(){
	window.open("index_DS_II.html","_newtab");
}

function hideHelp(){
	$("#openModalHelp").hide();
}

function showHelp(){
    var availableHeight=window.innerHeight-48;
    if(availableHeight>100){
        $("#openModalHelp").show();
        $("#helpContent").css("height","auto");        
        var maxHeight=$("#helpContent").height();
        var heightToUse=availableHeight<maxHeight?availableHeight:maxHeight;
        $("#helpContent").height(heightToUse);
    }
    else{
        alert("Δεν υπάρχει αρκετός διαθέσιμος χώρος για εμφάνιση του παράθυρου βοήθειας. Παρακαλώ μεγαλώστε το παράθυρο και δοκιμάστε ξανά.");
    }
}

function hideSimulationValues(){
    if(!showVarValues || simulationIndex!=0){
        $("#xStart").hide();
        $("#xStartStudent").hide();
    }
    if(!showVarValues || simulationIndex<1 || simulationIndex>=codeLength-1 || (currentSimulator==repeatSimulator && simulationIndex!=codeLength-1)){
        $("#xCond").hide();
        $("#xCondStudent").hide();
    }
    if(!showVarValues || simulationIndex!=outputIndex){
        $("#xOutput").hide();
        $("#xOutputStudent").hide();
    }
    if(!showVarValues || simulationIndex!=generateNewValueIndex){
        $("#xVal").hide();
        $("#xValStudent").hide();
    }
}

function simulateCode(){
	var simulationAborted=false;
    if(selectedSimulation==sourceCode || simulationInitialise()){
        programOutput="";
        switch(selectedSimulation){
            case sourceCode:
                codeLength=sourceCodeLength;
                if(exerciseType==for2While || exerciseType==for2Repeat){
                    currentSimulator=forSimulator;
                    outputIndex=1;
                    generateNewValueIndex=2;
                }
                else if(exerciseType==while2For || exerciseType==while2Repeat){
                    currentSimulator=whileSimulator;
                    if(selectedVariation==firstUseCounterThenChangeIt){
                        outputIndex=2;
                        generateNewValueIndex=3;
                    }
                    else{
                        generateNewValueIndex=2;
                        outputIndex=3;
                    }
                }
                else if(exerciseType==repeat2For || exerciseType==repeat2While){
                    currentSimulator=repeatSimulator;
                    if(selectedVariation==firstUseCounterThenChangeIt){
                        outputIndex=2;
                        generateNewValueIndex=3;
                    }
                    else{
                        generateNewValueIndex=2;
                        outputIndex=3;
                    }
                }
                if(sourceSpecialResults!=""){
                	$("#originalResults").html(sourceSpecialResults);
                	simulationAborted=true;
                }
                break;
            case studentCode:
                codeLength=studentCodeLength;
                if(exerciseType==while2For || exerciseType==repeat2For){
                    currentSimulator=forSimulator;
                    outputIndex=1;
                    generateNewValueIndex=2;
                }
                else if(exerciseType==for2While || exerciseType==repeat2While){
                    currentSimulator=whileSimulator;
                    if(selectedVariation==firstUseCounterThenChangeIt){
                        outputIndex=2;
                        generateNewValueIndex=3;
                    }
                    else{
                        generateNewValueIndex=2;
                        outputIndex=3;
                    }
                }
                else if(exerciseType==for2Repeat || exerciseType==while2Repeat){
                    currentSimulator=repeatSimulator;
                    if(selectedVariation==firstUseCounterThenChangeIt){
                        outputIndex=2;
                        generateNewValueIndex=3;
                    }
                    else{
                        generateNewValueIndex=2;
                        outputIndex=3;
                    }
                }
                if(studentSpecialResults!=""){
                	$("#studentResults").html(studentSpecialResults);
                	simulationAborted=true;
                }
                break;
        }
        //έναρξη προσομοίωσης με κλήση timer
        if(simulationAborted){
            $("#resultsArea").show();
            $("#messageArea").hide();
        }
        else{
            $("#btnContinue").hide();
            $("#btnForward").prop("disabled",true);
            $("#btnNewProblem").prop("disabled",true);
            $("#btnDelete").prop("disabled",true);
            $("#btnSubmit").prop("disabled",true);
            $("#btnShowSolution").prop("disabled",true);
            $("#btnPlaySource").prop("disabled",true);;
            $("#btnPlayStudent").prop("disabled",true);;
            $("#btnPause").prop("disabled",false);;
            $("#btnStop").prop("disabled",false);
            $("#btnOptions").prop("disabled",true);
        	timerLoop=setInterval(function(){simulationRun();},simSpeed);
        }
    }
}

function simulationInitialise(){
    simulationInitialised=true;

    if(selectedSimulation==studentCode){
        checkSolution();
    }
    
    var checkingField="";
    var fields=["startVal",
                "stepVal",
                "endVal",
                "comparator_endVal",
                "command1",
                "command2"];
    for(var i=0;i<fields.length;i++){
        if(exists(fields[i])){
            checkingField=trimSpaces(document.getElementById(fields[i]).innerHTML);
            if(checkingField=="")simulationInitialised=false;
        }
    }
    if(!simulationInitialised){
        alert("ΠΡΟΣΟΧΗ! Για την εκτέλεση του κώδικα απαιτείται συμπλήρωση όλων των κενών.");
    }
    return simulationInitialised;
}

function exists(elementID){
	var element=document.getElementById(elementID);
    if(typeof(element)!="undefined" && element!=null){
    	return true;
    }	
    else{
    	return false;
    }
}

function simulationReset(){
    clearInterval(timerLoop);
    $("#btnNewProblem").prop("disabled",false);
    $("#btnDelete").prop("disabled",false);
    $("#btnSubmit").prop("disabled",false);
    $("#btnShowSolution").prop("disabled",false);
    $(".simulatingCode").removeClass("simulatingCode");
    $("#btnContinue").hide();
    $("#btnForward").prop("disabled",true);
    $("#btnPlaySource").prop("disabled",false);
    $("#btnPlayStudent").prop("disabled",false);
    $("#btnPause").show();
    $("#btnPause").prop("disabled",true);
    $("#btnStop").prop("disabled",true);
    $("#btnOptions").prop("disabled",false);
    simulationIndex=-1;
    xInitialised=false;
    hideSimulationValues();
    simulationInitialised=false;
    currentSimulator=noSimulator;
}

function simulationRun(){
    var slctr="";
    var slctdResultsArea="";
    if(selectedSimulation==sourceCode){
        slctr="";
        slctdResultsArea="originalResults";
    }
    else{
        slctr="Student";
        slctdResultsArea="studentResults";
    }
    $("#sourceCodeDIV").css('position', 'relative');
    $("#sourceCodeDIV").zIndex(10);
    $("#studentCodeDIV").zIndex(5);

    //Οι επόμενες 2 εντολές τοποθετούνται εδώ και όχι στην simulateCode
    // για να λειτουργεί σωστά και η βηματική εκτέλεση
    $("#resultsArea").show();
    $("#messageArea").hide();

    simulationIndex++;
    var jStart=1;
    nxtSimulationIndex=simulationIndex;
    if(simulationIndex>codeLength){//Μετά την προσομοίωση της τελευταίας εντολής τερμάτισε το μηχανισμό προσομοίωσης
        simulationReset();
        return;
    }
    $(".simulatingCode").removeClass("simulatingCode");
    if(hideSimulationPath){
        jStart=simulationIndex+1;
    }
    //εμφάνιση μονοπατιού προσομοίωσης
    for(var j=jStart;j<=simulationIndex+1;j++){
        $("#cmd"+slctr+j).addClass("simulatingCode");
    }

    hideSimulationValues();
    
    if(selectedSimulation==sourceCode && (exerciseType==for2While || exerciseType==for2Repeat)  || selectedSimulation==studentCode && (exerciseType==while2For || exerciseType==repeat2For)){
        simulationFor(slctr);
    }
    else if(selectedSimulation==sourceCode && (exerciseType==while2For || exerciseType==while2Repeat) || selectedSimulation==studentCode && (exerciseType==for2While || exerciseType==repeat2While)){
        simulationWhile(slctr);
    }
    else if(selectedSimulation==sourceCode && (exerciseType==repeat2While || exerciseType==repeat2For) || selectedSimulation==studentCode && (exerciseType==while2Repeat || exerciseType==for2Repeat)){
        simulationRepeat(slctr);
    }

    simulationIndex=nxtSimulationIndex;
    var rsltDIV=document.getElementById(slctdResultsArea);
    rsltDIV.innerHTML="<span id='resultsTitle'>Αποτελέσματα εκτέλεσης</span><br><code>"+programOutput+"</code>";
    rsltDIV.scrollTop=rsltDIV.scrollHeight;
    //*//$("#"+slctdResultsArea).show();
}

function simulationFor(slctr){
    if(selectedSimulation==sourceCode){
        loopBegin=solutionStartVal;
        loopEnd=solutionEndVal;
        loopStep=solutionStepVal;
    }
    else{
        loopBegin=userStartVal;
        loopEnd=userEndVal;
        loopStep=userStepVal;
    }
    switch (simulationIndex){
        case 0: //Είσοδος στη Δομή Επανάληψης
            var xCondVal="ΑΛΗΘΗΣ";
            var xInitialisationInfo="";
            if(!xInitialised){
                xInitialised=true;
                xSim=loopBegin;
                xInitialisationInfo="x = "+xSim+" , ";
            }
            if(xSim>loopEnd && parseFloat(loopStep)>=0 || xSim<loopEnd && parseFloat(loopStep)<0){
                xCondVal="ΨΕΥΔΗΣ";
                nxtSimulationIndex=2;//Ολοκλήρωση Δομής
            }
            if(showVarValues){
                var comparator="<=";
                if(loopStep<0){
                    comparator=">=";
                }
                $("#xCond"+slctr).html(" "+xInitialisationInfo+xSim+" "+comparator+" "+loopEnd+" ["+xCondVal+"] ");
                $("#xCond"+slctr).show(animationRate);
            }
            break;
        case 1: //ΓΡΑΨΕ
            var debugInfo=" ";
            programOutput+=xSim+" ";
            debugInfo+="ΟΘΟΝΗ: "+xSim;
            if(showVarValues){
                $("#xOutput"+slctr).html(debugInfo+" ");
                $("#xOutput"+slctr).show(animationRate);
            }
            break;
        case 2: //ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ
            xSim+=parseFloat(loopStep);
            if(showVarValues){
                $("#xVal"+slctr).html(" x = "+xSim+" ");
                $("#xVal"+slctr).show(animationRate);
            }
            nxtSimulationIndex=-1;
            break;
    }
}

function simulationWhile(slctr){
	var loopBodyVariation=userSolutionVariation;
	if(slctr==""){
		loopBodyVariation=selectedVariation;
	}
    if(selectedSimulation==sourceCode){
        loopBegin=solutionStartVal;
        loopEnd=solutionEndVal;
        loopStep=solutionStepVal;
    }
    else{
        loopBegin=userStartVal;
        loopEnd=userEndVal;
        loopStep=userStepVal;
    }
    switch (simulationIndex){
        case 0: //Αρχικοποίηση x
            xSim=loopBegin;
            if(showVarValues){
                $("#xStart"+slctr).html(" x = "+xSim+" ");
                $("#xStart"+slctr).show(animationRate);
            }
            break;
        case 1: //Είσοδος στη Δομή Επανάληψης
            var xCondVal="ΑΛΗΘΗΣ";
            switch(solutionWhileComparator){
                case ">":
                    if(xSim<=loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
                case ">=":
                    if(xSim<loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
                case "<":
                    if(xSim>=loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
                case "<=":
                    if(xSim>loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
            }
            if(xCondVal=="ΨΕΥΔΗΣ"){
                nxtSimulationIndex=4;//Ολοκλήρωση Δομής
            }
            if(showVarValues){
                $("#xCond"+slctr).html(" "+xSim+" "+solutionWhileComparator+" "+loopEnd+" ["+xCondVal+"] ");
                $("#xCond"+slctr).show(animationRate);
            }
            break;
        case 2: //Πρώτη εντολή Δομής Επανάληψης
            if(loopBodyVariation==firstUseCounterThenChangeIt){
                simulationOutput(slctr,"xOutputStudent");
            }
            else{
                simulationChange(slctr,"xValStudent");
            }
            break;
        case 3: //Δεύτερη εντολή Δομής Επανάληψης
            if(loopBodyVariation==firstUseCounterThenChangeIt){
                simulationChange(slctr,"xValStudent");
            }
            else{
                simulationOutput(slctr,"xOutputStudent");
            }
            break;
        case 4: //ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ
            nxtSimulationIndex=0;
            break;
    }
}

function simulationRepeat(slctr){
	var loopBodyVariation=userSolutionVariation;
	if(slctr==""){
		loopBodyVariation=selectedVariation;
	}
    if(selectedSimulation==sourceCode){
        loopBegin=solutionStartVal;
        loopEnd=solutionEndVal;
        loopStep=solutionStepVal;
    }
    else{
        loopBegin=userStartVal;
        loopEnd=userEndVal;
        loopStep=userStepVal;
    }
    switch (simulationIndex){
        case 0: //Αρχικοποίηση x
            xSim=loopBegin;
            if(showVarValues){
                $("#xStart"+slctr).html(" x = "+xSim+" ");
                $("#xStart"+slctr).show(animationRate);
            }
            break;
        case 1: //Είσοδος στη Δομή Επανάληψης
            break;
        case 2: //Πρώτη εντολή Δομής Επανάληψης
            if(loopBodyVariation==firstUseCounterThenChangeIt){
                simulationOutput(slctr,"xOutputStudent");
            }
            else{
                simulationChange(slctr,"xValStudent");
            }
            break;
        case 3: //Δεύτερη εντολή Δομής Επανάληψης
            if(loopBodyVariation==firstUseCounterThenChangeIt){
                simulationChange(slctr,"xValStudent");
            }
            else{
                simulationOutput(slctr,"xOutputStudent");
            }
            break;
        case 4: //ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ
            var xCondVal="ΑΛΗΘΗΣ";
            switch(solutionRepeatComparator){
                case ">":
                    if(xSim<=loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
                case ">=":
                    if(xSim<loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
                case "<":
                    if(xSim>=loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
                case "<=":
                    if(xSim>loopEnd){
                        xCondVal="ΨΕΥΔΗΣ";
                    }
                    break;
            }
            if(xCondVal=="ΨΕΥΔΗΣ"){ //Επανάληψη Δομής
                nxtSimulationIndex=0;
            }
            if(showVarValues){
                $("#xCond"+slctr).html(" "+xSim+" "+solutionRepeatComparator+" "+loopEnd+" ["+xCondVal+"] ");
                $("#xCond"+slctr).show(animationRate);
            }
            break;
    }
}

function simulationChange(slctr,debugID){
    xSim+=parseFloat(loopStep);
    if(showVarValues){
    	if(slctr==""){
            $("#xVal").html(" x = "+xSim+" ");
            $("#xVal").show(animationRate);
    	}
    	else{
            $("#"+debugID).html(" x = "+xSim+" ");
            $("#"+debugID).show(animationRate);
    	}
    }
}

function simulationOutput(slctr,debugID){
    var debugInfo=" ";
    programOutput+=xSim+" ";
    debugInfo+="ΟΘΟΝΗ: "+xSim;
    if(showVarValues){
    	if(slctr==""){
    		$("#xOutput").html(debugInfo+" ");
    		$("#xOutput").show(animationRate);
    	}
    	else{
    		$("#"+debugID).html(debugInfo+" ");
    		$("#"+debugID).show(animationRate);
    	}
    }
}